
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>&lt;no title&gt; &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../../_static/css/theme.css" rel="stylesheet" />
  <link href="../../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/basic.css" />
    
  <link rel="preload" as="script" href="../../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../../" id="documentation_options" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../../index.html">
  <img src="../../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../../rst%20files/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="simple visible nav section-nav flex-column">
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drivee</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_24_06_15h&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span> <span class="o">+</span> <span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Drive already mounted at /content/gdrive; to attempt to forcibly remount, call drive.mount(&#34;/content/gdrive&#34;, force_remount=True).
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cuda&#39;, index=0)
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span>!pip install PyAstronomy
from FFNN import *
from Load_Save import *
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Requirement already satisfied: PyAstronomy in /usr/local/lib/python3.7/dist-packages (0.16.0)
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">time_step</span> <span class="o">=</span> <span class="mf">0.01</span>
<span class="n">fixed_len</span><span class="o">=</span><span class="kc">None</span>
<span class="n">begin_cycle</span> <span class="o">=</span> <span class="mi">10</span>
<span class="n">end_cycle</span> <span class="o">=</span> <span class="mi">100</span>
<span class="n">Q_lim</span> <span class="o">=</span> <span class="mf">0.9</span>
<span class="n">lim_cycle</span> <span class="o">=</span> <span class="kc">None</span>
<span class="n">model_type</span> <span class="o">=</span> <span class="mi">2</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/Severson et al./Cleaned&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//2. 2017-06-30&#39;</span><span class="p">)</span>
<span class="n">string</span> <span class="o">=</span> <span class="s1">&#39;Sev&#39;</span>

<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
    <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

<span class="k">if</span> <span class="n">string</span> <span class="o">==</span> <span class="s1">&#39;Sev&#39;</span><span class="p">:</span>

    <span class="n">train_len</span> <span class="o">=</span> <span class="mi">36</span>
    <span class="n">valid_len</span> <span class="o">=</span> <span class="mi">12</span>

    <span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">train_len</span><span class="p">)]</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">train_len</span><span class="p">,</span> <span class="mi">48</span><span class="o">-</span><span class="n">valid_len</span><span class="p">)]</span>

    <span class="nb">print</span><span class="p">(</span><span class="n">train</span><span class="p">,</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">ignore</span><span class="p">)</span>

    <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="c1"># Files to be ignored:</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">,</span>
                <span class="s1">&#39;B0054.txt&#39;</span><span class="p">]</span>

    <span class="c1"># The big one</span>
    <span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0018.txt&#39;</span><span class="p">,</span>  <span class="c1"># 24ºC</span>
                <span class="c1">#  &#39;B0025.txt&#39;, &#39;B0026.txt&#39;, &#39;B0027.txt&#39;,  # 24ºC</span>
                <span class="s1">&#39;B0029.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0031.txt&#39;</span><span class="p">,</span>  <span class="c1"># 43ºC</span>
                <span class="s1">&#39;B0036.txt&#39;</span><span class="p">,</span>  <span class="c1"># 24ºC</span>
                <span class="c1"># &#39;B0038.txt&#39;, &#39;B0039.txt&#39;,  # 44ºC et 24ºC</span>
                <span class="s1">&#39;B0042.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0043.txt&#39;</span><span class="p">,</span>  <span class="c1"># 44ºC et 4ºC</span>
                <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0046.txt&#39;</span><span class="p">]</span>  <span class="c1"># 4ºC</span>
                <span class="c1"># &#39;B0053.txt&#39;, &#39;B0055.txt&#39;]  # 4ºC</span>

    <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_SEV</span><span class="p">(</span><span class="n">Train_list</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
                                    <span class="n">begin_cycle</span><span class="o">=</span><span class="n">begin_cycle</span><span class="p">,</span>
                                    <span class="n">end_cycle</span><span class="o">=</span><span class="n">end_cycle</span><span class="p">,</span> <span class="n">Q_lim</span><span class="o">=</span><span class="n">Q_lim</span><span class="p">,</span>
                                    <span class="n">lim_cycle</span><span class="o">=</span><span class="n">lim_cycle</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                                    <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">model_type</span><span class="o">=</span><span class="n">model_type</span><span class="p">)</span>

<span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                            <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="k">if</span> <span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">sim_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                            <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">sim_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span>
                            <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>


<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>


<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_SEV</span><span class="p">(</span><span class="n">Valid_list</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
                                    <span class="n">begin_cycle</span><span class="o">=</span><span class="n">begin_cycle</span><span class="p">,</span>
                                    <span class="n">end_cycle</span><span class="o">=</span><span class="n">end_cycle</span><span class="p">,</span> <span class="n">Q_lim</span><span class="o">=</span><span class="n">Q_lim</span><span class="p">,</span>
                                    <span class="n">lim_cycle</span><span class="o">=</span><span class="n">lim_cycle</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                                    <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">model_type</span><span class="o">=</span><span class="n">model_type</span><span class="p">)</span>

<span class="k">if</span> <span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span>
                                <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[&#39;B0000.txt&#39;, &#39;B0001.txt&#39;, &#39;B0002.txt&#39;, &#39;B0003.txt&#39;, &#39;B0004.txt&#39;, &#39;B0005.txt&#39;, &#39;B0006.txt&#39;, &#39;B0007.txt&#39;, &#39;B0008.txt&#39;, &#39;B0009.txt&#39;, &#39;B0010.txt&#39;, &#39;B0011.txt&#39;, &#39;B0012.txt&#39;, &#39;B0013.txt&#39;, &#39;B0014.txt&#39;, &#39;B0015.txt&#39;, &#39;B0016.txt&#39;, &#39;B0017.txt&#39;, &#39;B0018.txt&#39;, &#39;B0019.txt&#39;, &#39;B0020.txt&#39;, &#39;B0021.txt&#39;, &#39;B0022.txt&#39;, &#39;B0023.txt&#39;, &#39;B0024.txt&#39;, &#39;B0025.txt&#39;, &#39;B0026.txt&#39;, &#39;B0027.txt&#39;, &#39;B0028.txt&#39;, &#39;B0029.txt&#39;, &#39;B0030.txt&#39;, &#39;B0031.txt&#39;, &#39;B0032.txt&#39;, &#39;B0033.txt&#39;, &#39;B0034.txt&#39;, &#39;B0035.txt&#39;]
 []
B0000
B0001
B0002
B0003
B0004
B0005
B0006
B0007
B0008
B0009
B0010
B0011
B0012
B0013
B0014
B0015
B0016
B0017
B0018
B0019
B0020
B0021
B0022
B0023
B0024
B0025
B0026
B0027
B0028
B0029
B0030
B0031
B0032
B0033
B0034
B0035
36
B0036
B0037
B0038
B0039
B0040
B0041
B0042
B0043
B0044
B0045
B0046
B0047
12
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="k">if</span> <span class="n">model_type</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
    <span class="n">intput_dim</span> <span class="o">=</span> <span class="mi">1</span>
<span class="k">elif</span> <span class="n">model_type</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
    <span class="n">input_dim</span> <span class="o">=</span> <span class="mi">6</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">FFNN_Sev</span><span class="p">(</span><span class="n">input_dim</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

<span class="n">simulate</span><span class="p">(</span><span class="n">sim_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
            <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/old_build_Google_Colabs_FFNN_Severson_4_0.png" src="../../_images/old_build_Google_Colabs_FFNN_Severson_4_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/old_build_Google_Colabs_FFNN_Severson_4_1.png" src="../../_images/old_build_Google_Colabs_FFNN_Severson_4_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">2000</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">1e-3</span>

<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span><span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span>
                                <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span>
                                <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">sim_loader</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
                                <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="c1"># Best model</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
            <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/usr/local/lib/python3.7/dist-packages/torch/nn/modules/loss.py:528: UserWarning: Using a target size (torch.Size([1])) that is different to the input size (torch.Size([1, 1])). This will likely lead to incorrect results due to broadcasting. Please ensure they have the same size.
  return F.mse_loss(input, target, reduction=self.reduction)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/old_build_Google_Colabs_FFNN_Severson_5_1.png" src="../../_images/old_build_Google_Colabs_FFNN_Severson_5_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  1980
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/old_build_Google_Colabs_FFNN_Severson_5_3.png" src="../../_images/old_build_Google_Colabs_FFNN_Severson_5_3.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/old_build_Google_Colabs_FFNN_Severson_5_4.png" src="../../_images/old_build_Google_Colabs_FFNN_Severson_5_4.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">Load_Save</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">analysis</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">epoch</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
          <span class="n">dataset_name</span><span class="o">=</span><span class="s1">&#39;Severson&#39;</span><span class="p">,</span> <span class="n">report_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0000.txt (used in training)
B0001.txt (used in training)
B0002.txt (used in training)
B0003.txt (used in training)
B0004.txt (used in training)
B0005.txt (used in training)
B0006.txt (used in training)
B0007.txt (used in training)
B0008.txt (used in training)
B0009.txt (used in training)
B0010.txt (used in training)
B0011.txt (used in training)
B0012.txt (used in training)
B0013.txt (used in training)
B0014.txt (used in training)
B0015.txt (used in training)
B0016.txt (used in training)
B0017.txt (used in training)
B0018.txt (used in training)
B0019.txt (used in training)
B0020.txt (used in training)
B0021.txt (used in training)
B0022.txt (used in training)
B0023.txt (used in training)
B0024.txt (used in training)
B0025.txt (used in training)
B0026.txt (used in training)
B0027.txt (used in training)
B0028.txt (used in training)
B0029.txt (used in training)
B0030.txt (used in training)
B0031.txt (used in training)
B0032.txt (used in training)
B0033.txt (used in training)
B0034.txt (used in training)
B0035.txt (used in training)
B0036.txt
B0037.txt
B0038.txt
B0039.txt
B0040.txt
B0041.txt
B0042.txt
B0043.txt
B0044.txt
B0045.txt
B0046.txt
B0047.txt
B0000.txt (used in training)
B0001.txt (used in training)
B0002.txt (used in training)
B0003.txt (used in training)
B0004.txt (used in training)
B0005.txt (used in training)
B0006.txt (used in training)
B0007.txt (used in training)
B0008.txt (used in training)
B0009.txt (used in training)
B0010.txt (used in training)
B0011.txt (used in training)
B0012.txt (used in training)
B0013.txt (used in training)
B0014.txt (used in training)
B0015.txt (used in training)
B0016.txt (used in training)
B0017.txt (used in training)
B0018.txt (used in training)
B0019.txt (used in training)
B0020.txt (used in training)
B0021.txt (used in training)
B0022.txt (used in training)
B0023.txt (used in training)
B0024.txt (used in training)
B0025.txt (used in training)
B0026.txt (used in training)
B0027.txt (used in training)
B0028.txt (used in training)
B0029.txt (used in training)
B0030.txt (used in training)
B0031.txt (used in training)
B0032.txt (used in training)
B0033.txt (used in training)
B0034.txt (used in training)
B0035.txt (used in training)
B0036.txt
B0037.txt
B0038.txt
B0039.txt
B0040.txt
B0041.txt
B0042.txt
B0043.txt
B0044.txt
B0045.txt
B0046.txt
B0047.txt
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/usr/local/lib/python3.7/dist-packages/torch/nn/modules/loss.py:97: UserWarning: Using a target size (torch.Size([1, 1])) that is different to the input size (torch.Size([1, 1, 1])). This will likely lead to incorrect results due to broadcasting. Please ensure they have the same size.
  return F.l1_loss(input, target, reduction=self.reduction)
/usr/local/lib/python3.7/dist-packages/torch/nn/modules/loss.py:528: UserWarning: Using a target size (torch.Size([1, 1])) that is different to the input size (torch.Size([1, 1, 1])). This will likely lead to incorrect results due to broadcasting. Please ensure they have the same size.
  return F.mse_loss(input, target, reduction=self.reduction)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># os.chdir(&#39;.//Reports/&#39; + str(date))</span>
<span class="c1"># load_info = (Train_info.best_epoch.nb + 1, train_dataset.batteries,</span>
<span class="c1">#                 None, fixed_len, time_step, True, None,</span>
<span class="c1">#                 train_dataset.norm, None, Model.nb_clusters)</span>

<span class="c1"># with open(&#39;load_info.txt&#39;, &#39;wb&#39;) as f:</span>
<span class="c1">#     pickle.dump(load_info, f)</span>
<span class="c1"># os.chdir(&#39;../../&#39;)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># for battery in Train_list:</span>
<span class="c1">#     if battery.cycle_couple[-1][1].data.capacity &gt; 0.89:</span>
<span class="c1">#         print(battery.Name, battery.cycle_life, battery.cycle_couple[-1][0].number, battery.cycle_couple[-1][1].data.capacity)</span>

<span class="c1"># for battery in Valid_list:</span>
<span class="c1">#     if battery.cycle_couple[-1][1].data.capacity &gt; 0.89:</span>
<span class="c1">#         print(battery.Name, battery.cycle_life, battery.cycle_couple[-1][0].number, battery.cycle_couple[-1][1].data.capacity)</span>
</pre></div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>